<link rel="import" href="../polymer/polymer.html">
<link rel="import" href="../paper-dialog/paper-dialog.html">
<link rel="import" href="../paper-dialog-scrollable/paper-dialog-scrollable.html">
<link rel="import" href="../iron-resizable-behavior/iron-resizable-behavior.html">
<link rel="import" href="../iron-dropdown/iron-dropdown-scroll-manager.html">
<link rel="import" href="../iron-icon/iron-icon.html">
<link rel="import" href="../iron-icons/iron-icons.html">

<!--
`<hook-modal>` is an element that houses both the creator spotlight element and a partnered modal with that element.  The parent container has a video parameter which takes a video ID from YouTube.  All content properties for both the modal and element are inside the parent container and are shown below.

### Example:

    <div is="hook-modal">
      <div card-content>...</div>
      <div modal-content>...</div>
    </div>

### Styling

The following custom properties and mixins are available for styling:

Custom property | Description | Default
----------------|-------------|----------
`--hook-modal-background` | The background color of the hook-modal
`--hook-modal` | Mixin applied to the element | `{}`

@element hook-modal
@demo demo/index.html
-->

<dom-module id="hook-modal">

  <template>

    <style>

      /* Host styles */

      :host {
        background: var(--hook-modal-background, white);

        @apply(--hook-modal);
      }

      #scrolling {
        --paper-dialog-scrollable: {
          max-width: 100%;
          padding: 0 0;
        }
      }

      #modal-content {
        margin: 0 24px;
      }

      /* Card styles */

      #card-content {
        cursor: pointer;
      }

      #card-content ::content img,
      #modal-content ::content img {
        border-radius: 50%;
      }

      /* Modal styles */

      #modal {
        width: 100%;
        margin: 0;
        max-width: 750px;
        padding: 45px 24px;
      }

      #scrolling {
        margin: 0;
      }

      /* Close button styles */

       #close {
         position: absolute;
         top: 4px;
         right: 12px;
         z-index: 1;
         margin: 0;
         padding: 0;
       }

       :host-context([dir=rtl]) #close {
         right: auto;
         left: 25px;
       }

       #close .icon {
         cursor: pointer;
         display: block;
         iron-icon-height: 16px;
         iron-icon-width: 16px;
         color: #000;
         overflow: auto;
         padding: 20px;
       }

      @media screen and (max-width: 767px) {

        #modal {
          text-align: left;
        }

        #modal-content {
          margin: 0 43px;
        }

        #close {
          top: 0;
          right: 15px;
        }

        :host-context([dir=rtl]) #close {
          right: auto;
          left: 15px;
        }
      }

    </style>

    <div id="card">

      <div id="card-content" on-tap="_openModal">
        <content select="[card-content]"></content>
      </div>

    </div>

    <!-- modal -->
    <paper-dialog id="modal" with-backdrop always-on-top on-iron-overlay-opened="_onModalOpen" on-iron-overlay-closed="_onModalClose">

      <div id="close">
        <iron-icon icon="icons:close" class="icon" on-tap="_closeModal">x</iron-icon>
      </div>

      <paper-dialog-scrollable id="scrolling" dialog-element="[[modal]]">

        <div id="modal-content">
          <content select="[modal-content]"></content>
        </div>

      </paper-dialog-scrollable>

    </paper-dialog>

  </template>

  <script>
  (function() {
    'use strict';

    Polymer({

      is: 'hook-modal',

      extends: 'div',

      /**
       * Element Behavior
       * @type {Array}
       */
      behaviors: [Polymer.IronResizableBehavior],

      /**
       * Element Listeners
       * @type {Object}
       */

      listeners: {
        'iron-resize': '_onResize',
        'iron-overlay-closed': '_removeBackdrop',
      },

      /**
       * Element Properties
       * @type {Object}
       */

      properties: {
        modal: {
          type: Object,
          value: function() {
            return this.$.modal;
          }
        },
        noscrollClass: {
          type: String,
          value: 'yt-noscroll'
        }
      },

      /**
       * Remove backdrop for IE 10.
       */
      _removeBackdrop: function(e) {

        if (navigator.appVersion.indexOf("MSIE 10") !== -1) {

          var backdrop = this.$.modal.backdropElement;
          backdrop.parentNode.removeChild(backdrop);

        }

      },

      /**
       * Opens modal
       */
      _openModal: function(e) {

        if (!this.$.modal.opened) {
          this.$.modal.open();
        }

      },

      /**
       * Close modal
       */
      _closeModal: function() {

        this.$.modal.close();

      },

      /**
       * Cancel scroll on body while modal is open
       */
      _cancelScroll: function(e) {

        var scrollable = this.$.scrolling.scrollTarget;
        var max = scrollable.scrollHeight - scrollable.offsetHeight;

        if (scrollable.scrollTop <= 0) {
          scrollable.scrollTop = 1;
          e.preventDefault();
        } else if (scrollable.scrollTop >= max) {
          scrollable.scrollTop = max - 1;
          e.preventDefault();
        }

      },

      /**
       * Kills backdrop if screen width is less than 768.
       */
      _onResize: function() {

        if (this.$.modal.opened) {

          this._enableScroll();
          this._disableScroll();
          this.$.modal.fit();

        }

      },

      /**
       * Kills scrolling if modal is open.
       */
      _onModalOpen: function(e) {

        this._disableScroll();

      },

      /**
       * Removes kill scroll function if modal is closed.
       */
      _onModalClose: function() {

        var video = this.querySelector('[is=yt-creator-hub-video]');

        if (video && video.isPlaying()) {
          video.pause();
        }

        this._enableScroll();

      },

      /**
       * Enable scrolling
       */
      _enableScroll: function() {

        this.unlisten(document.documentElement, 'touchmove', '_cancelScroll');
        this.toggleClass(this.noscrollClass, false, document.documentElement);
        this.toggleClass(this.noscrollClass, false, document.body);
        Polymer.IronDropdownScrollManager.removeScrollLock(this.$.modal);

      },

      /**
       * Disable scrolling
       */
      _disableScroll: function() {

        this.listen(document.documentElement, 'touchmove', '_cancelScroll');
        this.toggleClass(this.noscrollClass, true, document.documentElement);
        this.toggleClass(this.noscrollClass, true, document.body);
        Polymer.IronDropdownScrollManager.pushScrollLock(this.$.modal);

        this.$.modal.center();

      }

    });

  })();
  </script>

</dom-module>
